org.apache.lucene.index

## Class MultiTermsEnum

- java.lang.Object
- - org.apache.lucene.index.TermsEnum
  - - org.apache.lucene.index.BaseTermsEnum
    - - org.apache.lucene.index.MultiTermsEnum

- All Implemented Interfaces:
    BytesRefIterator

      public final class MultiTermsEnum
      extends BaseTermsEnum

  Exposes `TermsEnum` API, merged from `TermsEnum` API of sub-segments. This does a merge sort, by term text, of the sub-readers.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.TermsEnum

      `TermsEnum.SeekStatus`

  - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.index.TermsEnum

      `EMPTY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MultiTermsEnum(ReaderSlice[] slices)` Sole constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `docFreq()` Returns the number of documents containing the current term.
    `org.apache.lucene.index.MultiTermsEnum.TermsEnumWithSlice[]` | `getMatchArray()` Returns sub-reader slices positioned to the current term.
    `int` | `getMatchCount()` Returns how many sub-reader slices contain the current term.
    `ImpactsEnum` | `impacts(int flags)` Return a `ImpactsEnum`.
    `BytesRef` | `next()` Increments the iteration to the next `BytesRef` in the iterator.
    `long` | `ord()` Returns ordinal position for current term.
    `PostingsEnum` | `postings(PostingsEnum reuse, int flags)` Get `PostingsEnum` for the current term, with control over whether freqs, positions, offsets or payloads are required.
    `TermsEnum` | `reset(org.apache.lucene.index.MultiTermsEnum.TermsEnumIndex[] termsEnumsIndex)` The terms array must be newly created TermsEnum, ie `BytesRefIterator.next()` has not yet been called.
    `TermsEnum.SeekStatus` | `seekCeil(BytesRef term)` Seeks to the specified term, if it exists, or to the next (ceiling) term.
    `boolean` | `seekExact(BytesRef term)` Attempts to seek to the exact term, returning true if the term is found.
    `void` | `seekExact(long ord)` Seeks to the specified term by ordinal (position) as previously returned by `TermsEnum.ord()`.
    `BytesRef` | `term()` Returns current term.
    `String` | `toString()`
    `long` | `totalTermFreq()` Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term).

    - ### Methods inherited from class org.apache.lucene.index.BaseTermsEnum

      `attributes, seekExact, termState`

    - ### Methods inherited from class org.apache.lucene.index.TermsEnum

      `postings`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### MultiTermsEnum

          public MultiTermsEnum(ReaderSlice[] slices)

      Sole constructor.
      Parameters:
        `slices` - Which sub-reader slices we should merge.

  - ### Method Detail

    - #### getMatchCount

          public int getMatchCount()

      Returns how many sub-reader slices contain the current term. @see #getMatchArray

    - #### getMatchArray

          public org.apache.lucene.index.MultiTermsEnum.TermsEnumWithSlice[] getMatchArray()

      Returns sub-reader slices positioned to the current term.

    - #### term

          public BytesRef term()

      Description copied from class: `TermsEnum`
      Returns current term. Do not call this when the enum is unpositioned.
      Specified by:
        `term` in class `TermsEnum`

    - #### reset

          public TermsEnum reset(org.apache.lucene.index.MultiTermsEnum.TermsEnumIndex[] termsEnumsIndex)
                          throws IOException

      The terms array must be newly created TermsEnum, ie `BytesRefIterator.next()` has not yet been called.
      Throws:
        `IOException`

    - #### seekExact

          public boolean seekExact(BytesRef term)
                            throws IOException

      Description copied from class: `TermsEnum`
      Attempts to seek to the exact term, returning true if the term is found. If this returns false, the enum is unpositioned. For some codecs, seekExact may be substantially faster than `TermsEnum.seekCeil(org.apache.lucene.util.BytesRef)`.

      Overrides:
        `seekExact` in class `BaseTermsEnum`
      Returns:
        true if the term is found; return false if the enum is unpositioned.
      Throws:
        `IOException`

    - #### seekCeil

          public TermsEnum.SeekStatus seekCeil(BytesRef term)
                                        throws IOException

      Description copied from class: `TermsEnum`
      Seeks to the specified term, if it exists, or to the next (ceiling) term. Returns SeekStatus to indicate whether exact term was found, a different term was found, or EOF was hit. The target term may be before or after the current term. If this returns SeekStatus.END, the enum is unpositioned.
      Specified by:
        `seekCeil` in class `TermsEnum`
      Throws:
        `IOException`

    - #### seekExact

          public void seekExact(long ord)

      Description copied from class: `TermsEnum`
      Seeks to the specified term by ordinal (position) as previously returned by `TermsEnum.ord()`. The target ord may be before or after the current ord, and must be within bounds.
      Specified by:
        `seekExact` in class `TermsEnum`

    - #### ord

          public long ord()

      Description copied from class: `TermsEnum`
      Returns ordinal position for current term. This is an optional method (the codec may throw `UnsupportedOperationException`). Do not call this when the enum is unpositioned.
      Specified by:
        `ord` in class `TermsEnum`

    - #### next

          public BytesRef next()
                        throws IOException

      Description copied from interface: `BytesRefIterator`
      Increments the iteration to the next `BytesRef` in the iterator. Returns the resulting `BytesRef` or `null` if the end of the iterator is reached. The returned BytesRef may be re-used across calls to next. After this method returns null, do not call it again: the results are undefined.
      Returns:
        the next `BytesRef` in the iterator or `null` if the end of the iterator is reached.
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### docFreq

          public int docFreq()
                      throws IOException

      Description copied from class: `TermsEnum`
      Returns the number of documents containing the current term. Do not call this when the enum is unpositioned. `TermsEnum.SeekStatus.END`.
      Specified by:
        `docFreq` in class `TermsEnum`
      Throws:
        `IOException`

    - #### totalTermFreq

          public long totalTermFreq()
                             throws IOException

      Description copied from class: `TermsEnum`
      Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term). Note that, like other term measures, this measure does not take deleted documents into account.
      Specified by:
        `totalTermFreq` in class `TermsEnum`
      Throws:
        `IOException`

    - #### postings

          public PostingsEnum postings(PostingsEnum reuse,
                                       int flags)
                                throws IOException

      Description copied from class: `TermsEnum`
      Get `PostingsEnum` for the current term, with control over whether freqs, positions, offsets or payloads are required. Do not call this when the enum is unpositioned. This method will not return null.

      NOTE: the returned iterator may return deleted documents, so deleted documents have to be checked on top of the `PostingsEnum`.

      Specified by:
        `postings` in class `TermsEnum`
      Parameters:
        `reuse` - pass a prior PostingsEnum for possible reuse
        `flags` - specifies which optional per-document values you require; see `PostingsEnum.FREQS`
      Throws:
        `IOException`

    - #### impacts

          public ImpactsEnum impacts(int flags)
                              throws IOException

      Description copied from class: `TermsEnum`
      Return a `ImpactsEnum`.
      Specified by:
        `impacts` in class `TermsEnum`
      Throws:
        `IOException`
      See Also:
        `TermsEnum.postings(PostingsEnum, int)`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2000-2019 Apache Software Foundation. All Rights Reserved.